#if !defined  HAVE_ITH_ONE_IDX_H__
#define       HAVE_ITH_ONE_IDX_H__


#include "bits/bitsperlong.h"
#include "fxttypes.h"

inline ulong ith_one_idx(ulong x, ulong i)
// Return index of the i-th set bit of x
// where 0<=i<ct and ct == bit_count(x).
{
#if  BITS_PER_LONG == 32
    ulong y = x - ((x>>1) & 0x55555555UL);             // 0-2 in 2 bits
    y = ((y>>2) & 0x33333333UL) + (y & 0x33333333UL);  // 0-4 in 4 bits
    y = ((y>>4) + y) & 0x0f0f0f0fUL;                   // 0-8 in 8 bits
    ulong ct = (y*0x01010101UL) >> 24;  // bit count
#else
    ulong y = x - ((x>>1) & 0x5555555555555555UL);                     // 0-2 in 2 bits
    y = ((y>>2) & 0x3333333333333333UL) + (y & 0x3333333333333333UL);  // 0-4 in 4 bits
    y = ((y>>4) + y) & 0x0f0f0f0f0f0f0f0fUL;                           // 0-8 in 8 bits
    ulong ct = (y * 0x0101010101010101UL) >> 56;  // bit count
#endif

    if ( ct <= i )  return ~0UL;  // less than i bits set

    ulong s = 0;
    while ( i >= (y & 0xff) )  // scan over bytes
    {
        i -= (y & 0xff);
        y >>= 8;
        s += 8;
    }
    x >>= s;

    --s;  ++i;  // allow test for zero
    while ( i )  // scan over bits
    {
        i -=  x & 1;
        x >>= 1;
        ++s;
    }

    return s;
}
// -------------------------


#endif  // !defined HAVE_ITH_ONE_IDX_H__
